/*
 PTHPasteboard Keygen
 This code will create a valid license file to use with PTHPasteboard.
 Grabs en0 interface mac address (code ripped from Mac OS X ifconfig),
 generates the needed digests, creates the licence file, encrypts it and base64
 encodes it.
 
 There is one licence file which isn't encrypted.
 
 This code is for educational/learning purposes. Do not use it for piracy :)
 I'm not responsable whatsoever by any utilization of this code.
 
 It's a bit big and unorganized... I'm not a l33t C coder! Sorry...
 But at least it's a good example about openssl API usage!
 
 (c) fG! 2008

 Compile with gcc -o keygen keygen.c -lcrypto
 
*/

/* standard stuff */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <getopt.h>
/* openssl includes */
#include <openssl/evp.h>
#include <openssl/rsa.h>
#include <openssl/err.h>

#define VERSION "1.0"
#define INTERFACE "en0"

void usage (void);
void getmac (void);

char 	macaddress[18];

void usage()
{
	printf(
	"PTHPasteboard v4.4.0 Keygen v%s (c) fG! 2008\n\n"
	"usage: keygen [--debug] --private=<privatekey> [--public=<publickey>]\n\n"
	"Where:\n"
	"<privatekey> : full path to private key file\n"
	"<publickey>  : full path to public key file (if debug is turned on)\n"
	"debug        : to enable debug messages and tests (public key required)\n\n", VERSION
	);
	exit(1);
}

main(int argc, char *argv[])
{

 int debug = 0;
 EVP_MD_CTX signctx, tempctx;
 BIO *bio_mem, *bio64, *bio_out;
 FILE *pkey_in, *licencefile;
 EVP_PKEY *pkey;
 int i, err;
 unsigned int sig_len, temp_len;
 char expirationdate[] = "2100-12-31";
 // change the serial number if you want (keep it the same size)...
 char serialnumber[] = "457197241258";
 char name[256], *pname;
 char *privatekeylocation, *publickeylocation;
 unsigned char temp_value[EVP_MAX_MD_SIZE];
// info for the license digest
 static char productversion[] = "4";
 static char productname[] = "PTHPasteboard";

// required structure for long options
 static struct option long_options[]={
	{ "private", required_argument, NULL, 'p' },
	{ "public", required_argument, NULL, 'u' },
	{ "debug", no_argument, NULL, 'd' },
	{ NULL, 0, NULL, 0 }
 };
 int option_index = 0, c;

 // process command line options
 while ((c = getopt_long (argc, argv, "dp:u:", long_options, &option_index)) != -1)
 {
	switch (c)
	{
		case ':':
		 usage();
		 break;
		case '?':
		 usage();
		 break;
		case 'd':
		 debug = 1;
		 break;		case 'p':		 privatekeylocation = optarg;		 break;
		case 'u':
		 publickeylocation = optarg;
		 break;		default:
		 usage();	}
 }

 // check arguments
 if(argc<2)
 	usage();

 if(debug && publickeylocation == NULL)
 {
  	fprintf(stderr,"ERROR: Debug requires public key parameter!\n\n");
  	usage();
 }

 // load the error strings
 ERR_load_crypto_strings();
 
 // Open the private key
 if ( (pkey_in = fopen(privatekeylocation, "r")) == NULL)
 {
  fprintf(stderr, "\nERROR: Error while opening private key file %s\n\n", privatekeylocation);
  exit(1);
 }
 // load private key
 pkey = PEM_read_PrivateKey(pkey_in, NULL, NULL, NULL);
 if (pkey == NULL)
 {
 	printf("ERROR: ");
	ERR_print_errors_fp (stderr);
	exit (1);
 }
 fclose(pkey_in);

// Get input data
 printf("Insert name:\n");
 fflush(stdout);
 fgets(name, 256, stdin);
 if ((pname = strchr(name, '\n')) != NULL)
 {
  *pname = '\0';
 }

 // retrieve mac address
 getmac();
 if(debug) printf("Mac address is: %s\n", macaddress);

 int x=0;
 int y=0;
 char macaddress2[12];
 // crappy & lame search and replace!
 while (macaddress[x] != '\0')
 {
 	if (macaddress[x] == ':');
 	else
 	{
 	 	macaddress2[y++] = macaddress[x];
 	}
 	x++;
 }	
 macaddress2[12] = '\0';
 
 if(debug) printf("Mac address 2 is: %s\n",macaddress2);
 
 // construct the hash data
 char hashdata[80];
 snprintf(hashdata,sizeof(hashdata), "%s.%s.%s.%s.2100-12-31T00:00:00Z\0",productname,productversion,macaddress2,serialnumber);

 if (debug) printf("Hash Data is: %s Size is: %d\n", hashdata,strlen(hashdata));
 
 // initialize a signature for licence file, with SHA1
 // SignUpdate function is what we look for, since this function uses the DigestUpdate functions to hash data
 EVP_SignInit(&signctx,EVP_sha1());
 // hash required data into signature context
 // what needs to be hashed is:
 // PTHPasteboard.4.XXXXXXXXXXXX.YYYYYYYYYYY.2008-10-10T00:00:00Z
 EVP_SignUpdate(&signctx, hashdata, strlen(hashdata));
 
 // this code will show the computed digest for licence file
 if (debug)
 {
	// create a copy of the ctx so we can create a digest to display ! we must always initialize temp ctx
	 EVP_MD_CTX_init(&tempctx); 
	// copy from signctx to tempctx
 	EVP_MD_CTX_copy_ex(&tempctx, &signctx); 
	// finalize the digest
 	EVP_DigestFinal_ex(&tempctx, temp_value, &temp_len);
 	EVP_MD_CTX_cleanup(&tempctx);
 	printf("Digested %d bytes\n",temp_len);
 	printf("Licence Digest is: ");
 	for(i = 0; i < temp_len; i++) printf("%02x", temp_value[i]);
 	printf("\n");
 }
 
 int pkeysize; 
 pkeysize = EVP_PKEY_size(pkey);
 unsigned char result[pkeysize];
 
 if (debug) printf("Key size is:%d\n",pkeysize);

 // sign hashed data with private key and put the result into buffer
 err = EVP_SignFinal(&signctx, result, &sig_len, pkey);
 if (err != 1) 
 {
 	ERR_print_errors_fp(stderr);
 	exit (1);
 }

 if (debug)
 {
	// print signature in hex 
 	printf("Generating...\nLicence file Signature in hex is:\n");
 	for(i = 0; i < sig_len; i++) printf("%02x", result[i]);
 	printf("\nEnd of licence file signature\n");
 }
 
 // clean private key
 EVP_PKEY_free (pkey);
 
 if (debug)
 { 
	/* Read public key */
 	if ( (pkey_in = fopen(publickeylocation, "r")) == NULL)
 	{
  		fprintf(stderr, "\nERROR: Error while opening public key file %s\n\n", publickeylocation);
  		exit(1);
 	}
	// load public key
 	pkey = PEM_read_PUBKEY(pkey_in, NULL, NULL, NULL);
 	if (pkey == NULL)
 	{
 		printf("ERROR: ");
  		ERR_print_errors_fp (stderr);
  		exit (1);
 	}
 	fclose(pkey_in);
 }
 
 if (debug)
 {
	// check if our generated licence signature is valid, 1 is OK, 0 failure 
 	err = EVP_VerifyFinal(&signctx, result, sig_len, pkey);
 	printf("Testing licence signature...\nLicence Signature Status is: %d\n", err);
 }

// clean context to avoid memory leaks
 EVP_MD_CTX_cleanup(&signctx);

 /*
   generate licence base64 encoded signature
 */
 
 if (debug) printf("Generating licence file...\n");
 
 if (debug) printf("Size of result is: %d\n", sizeof(result));
 // bio for output
 // this one will output to stdout
 // bio_mem = BIO_new_fp(stdout,BIO_NOCLOSE);
 // we want a mem BIO to hold the buffer
 bio_mem = BIO_new(BIO_s_mem());
 // base64 filter
 bio64 = BIO_new(BIO_f_base64());
 // create chain
 bio_out = BIO_push(bio64, bio_mem);
 // write
 BIO_write(bio_out, result, sizeof(result));
 // flush buffers, very important !
 BIO_flush(bio_out);

 /* long BIO_get_mem_data(BIO *b, char **pp)
   BIO_get_mem_data() sets pp to a pointer to the start of the memory BIOs
   data and returns the total amount of data available. It is implemented
   as a macro.

 IMPORTANT: It doesn't nul terminate !
 
 */
 char *signaturebuffer;
 int getmemlength=0;
 getmemlength = BIO_get_mem_data(bio_mem, &signaturebuffer);
 // nul terminate the buffer !!!
 signaturebuffer[getmemlength] = '\0';
   
 char licenceoutput[4096];  
 // send the output to a buffer so we can encrypt it 
 snprintf(licenceoutput,sizeof(licenceoutput),
 "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
 "<!DOCTYPE plist PUBLIC \"-//Apple Computer//DTD PLIST 1.0//EN\" \"http://www.apple.com/DTDs/PropertyList-1.0.dtd\">\n"
 "<plist version=\"1.0\">\n"
 "<dict>\n"
 "<key>expirationDate</key>\n"
 "<date>%sT00:00:00Z</date>\n"
 "<key>licenseSum</key>\n"
 "<data>\n%s"
 "</data>\n"
 "<key>productName</key>\n"
 "<string>%s</string>\n"
 "<key>productVersion</key>\n"
 "<integer>%s</integer>\n"
 "<key>registeredEmail</key>\n"
 "<string>someone@someone.com</string>\n"
 "<key>registeredName</key>\n"
 "<string>%s</string>\n"
 "<key>serialNumber</key>\n"
 "<string>%s</string>\n"
 "</dict>\n"
 "</plist>\n\0",
 expirationdate,signaturebuffer,productname,productversion,name,serialnumber);
 // free BIO
 BIO_free_all(bio_mem);

 // create licence file name
 // format is 000000000000.4.licenseKey
 // where 00-00 ... is mac address
 
 char licencefilename[60];
 // macaddress2 format was previously created
 snprintf(licencefilename,sizeof(licencefilename), "%s.4.licenseKey\0", macaddress2);
 
 // create the licence file
 if ( (licencefile = fopen(licencefilename, "wb")) == NULL)
 {
 	fprintf(stderr, "\nERROR: Error while opening licence file %s\n\n", licencefilename);
 	exit(1);
 }
 
  fprintf(licencefile, "%s", licenceoutput);

 // and voila, the end !
 printf("\nAll done !\n\n"
 "You will need to copy %s file to homedir/Library/Application Support/PTHPasteboard/\n"
 "\nHave fun!\n(c) 2008 fG!\n\n",
 licencefilename);
 
}

/*
 Retrieve Mac Address code
 This should have been in a separate source file ;) 
 Ripped from Apple ifconfig source... Oh yeah!
*/

#include <sys/param.h>
#define KERNEL_PRIVATE
#include <sys/ioctl.h>
#undef KERNEL_PRIVATE
#include <sys/socket.h>
#include <sys/sysctl.h>
#include <sys/time.h>

#include <net/ethernet.h>
#include <net/if.h>
#include <net/if_var.h>
#include <net/if_dl.h>
#include <net/if_types.h>
#include <net/route.h>

/* IP */
#include <netinet/in.h>
//#include <netinet/in_var.h>
//#include <arpa/inet.h>
//#include <netdb.h>

#include <ctype.h>
#include <err.h>
#include <errno.h>
#include <fcntl.h>
//#include <stdio.h>
//#include <stdlib.h>
//#include <string.h>
//#include <unistd.h>

struct	ifreq		ifr, ridreq;
struct	ifaliasreq	addreq;
struct	sockaddr_in	netmask;

char	name[16];

int	flags;
int	metric;
int	mtu;
int	setaddr;
int	setipdst;
int	setmask;
int	doalias;
int	clearaddr;
int	newaddr = 1;

struct	afswtch;

void	status __P((const struct afswtch *afp, int addrcount,
		    struct sockaddr_dl *sdl, struct if_msghdr *ifm,
		    struct ifa_msghdr *ifam));

typedef	void af_status __P((int, struct rt_addrinfo *));
typedef	void af_getaddr __P((const char *, int));
typedef void af_getprefix __P((const char *, int));

af_status	ether_status;
af_getaddr	ether_getaddr;

/* Known address families */
const
struct	afswtch {
	const char *af_name;
	short af_af;
	af_status *af_status;
	af_getaddr *af_getaddr;
	af_getprefix *af_getprefix;
	u_long af_difaddr;
	u_long af_aifaddr;
	caddr_t af_ridreq;
	caddr_t af_addreq;
} afs[] = {
#define C(x) ((caddr_t) &x)
	{ "ether", AF_LINK, ether_status, ether_getaddr, NULL,
	     0, SIOCSIFLLADDR, NULL, C(ridreq) },
	{ 0,	0,	    0,		0 }
};

#define RIDADDR 0
#define ADDR	1
#define NMASK	2
#define DSTADDR	3

void getmac()
{
	int foundit = 0;
	const struct afswtch *afp = 0;
	int addrcount;
	struct	if_msghdr *ifm, *nextifm;
	struct	ifa_msghdr *ifam;
	struct	sockaddr_dl *sdl;
	char	*buf, *lim, *next;

	size_t needed;
	int mib[6];

// interface name we want to retrieve mac address
	strcpy(name, INTERFACE);

	mib[0] = CTL_NET;
	mib[1] = PF_ROUTE;
	mib[2] = 0;
	mib[3] = 2;	/* AF_INET address family */
	mib[4] = NET_RT_IFLIST;
	mib[5] = 0;

	if (sysctl(mib, 6, NULL, &needed, NULL, 0) < 0)
		errx(1, "iflist-sysctl-estimate");
	if ((buf = malloc(needed)) == NULL)
		errx(1, "malloc");
	if (sysctl(mib, 6, buf, &needed, NULL, 0) < 0)
		errx(1, "actual retrieval of interface table");
	lim = buf + needed;

	next = buf;
	while (next < lim) {
		ifm = (struct if_msghdr *)next;
				
		if (ifm->ifm_type == RTM_IFINFO) {
			sdl = (struct sockaddr_dl *)(ifm + 1);
			flags = ifm->ifm_flags;
		} else {
			fprintf(stderr, "out of sync parsing NET_RT_IFLIST\n");
			fprintf(stderr, "expected %d, got %d\n", RTM_IFINFO, ifm->ifm_type);
			fprintf(stderr, "msglen = %d\n", ifm->ifm_msglen);
			fprintf(stderr, "buf:%p, next:%p, lim:%p\n", buf, next, lim);
			exit (1);
		}

		next += ifm->ifm_msglen;
		ifam = NULL;
		addrcount = 0;
		while (next < lim) {
			nextifm = (struct if_msghdr *)next;

			if (nextifm->ifm_type != RTM_NEWADDR)
				break;

			if (ifam == NULL)
				ifam = (struct ifa_msghdr *)nextifm;

			addrcount++;
			next += nextifm->ifm_msglen;
		}
		if (strlen(name) != sdl->sdl_nlen)
			continue; 

// check if it's our specific interface, if yes then get status, else keep searching
		if (strncmp(name, sdl->sdl_data, sdl->sdl_nlen) != 0)
			continue; 

		status(afp, addrcount, sdl, ifm, ifam);
		foundit++;
		break;
	}
	free(buf);
	if (foundit == 0)
		errx(1, "interface %s does not exist", name);
}


/*
 * Retrieve the status of the interface.
 */
void
status(afp, addrcount, sdl, ifm, ifam)
	const struct afswtch *afp;
	int addrcount;
	struct	sockaddr_dl *sdl;
	struct if_msghdr *ifm;
	struct ifa_msghdr *ifam;
{
	int allfamilies, s;
	
	if (afp == NULL)
	{
		allfamilies = 1;
		afp = &afs[0];
	} else
		allfamilies = 0;

	ifr.ifr_addr.sa_family = AF_INET;

	strncpy(ifr.ifr_name, name, sizeof ifr.ifr_name);

	if ((s = socket(ifr.ifr_addr.sa_family, SOCK_DGRAM, 0)) < 0)
		err(1, "socket");

	if (allfamilies || afp->af_status == ether_status)
		ether_status(s, (struct rt_addrinfo *)sdl);
		
	close(s);
	return;
}

void
ether_status(s, info)
	int s ;
	struct rt_addrinfo *info;
{
	char *cp, *tempptr;		
	int n;
	struct sockaddr_dl *sdl = (struct sockaddr_dl *)info;

	// temporary pointer to the array
	tempptr=macaddress;
	cp = (char *)LLADDR(sdl);
			
	if ((n = sdl->sdl_alen) > 0)
	{
      	while (--n >= 0)
      	{
		    snprintf(tempptr,4,"%02x%c",*cp++ & 0xff, n>0? ':' : '\0');
			// move to next position
		    tempptr +=3;
		}
	}
}

void  
ether_getaddr(addr, which)
        const char *addr;
        int which;
{
        struct ether_addr *ea;
        struct sockaddr *sea = &ridreq.ifr_addr;

        ea = ether_aton(addr);
        if (ea == NULL)
                errx(1, "malformed ether address");
        if (which == NMASK)
                errx(1, "Ethernet does not use netmasks");
        sea->sa_family = AF_LINK;
        sea->sa_len = ETHER_ADDR_LEN;      
        bcopy(ea, sea->sa_data, ETHER_ADDR_LEN);
}
